#include <iostream>
#include <vector>

using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
};

//
Input input_data() {
    size_t number_count;
    cout << "  : ";
    cin >> number_count;

    Input in; //   Input
    in.numbers.resize(number_count); //   

    cout << " :\n";
    for (size_t i = 0; i < number_count; i++) {
        cin >> in.numbers[i]; //   
    }

    cout << "  : ";
    cin >> in.bin_count; //   

    return in; //  
}

//   
void find_minmax(const vector<double>& numbers, double& min, double& max) {
    min = numbers[0];
    max = numbers[0];
    for (double x : numbers) {
        if (x < min) {
            min = x;
        }
        if (x > max) {
            max = x;
        }
    }
}

// 
vector<size_t> make_histogram(const vector<double>& numbers, size_t bin_count) {
    double min, max;
    find_minmax(numbers, min, max);

    double bin_size = (max - min) / bin_count;
    vector<size_t> bins(bin_count, 0);

    for (double number : numbers) {
        size_t bin_index = static_cast<size_t>((number - min) / bin_size);
        if (bin_index >= bin_count) {
            bin_index = bin_count - 1;
        }
        bins[bin_index]++;
    }

    return bins;
}

//
void show_histogram_text(const vector<size_t>& bins, double min, double bin_size) {
    for (size_t i = 0; i < bins.size(); i++) {
        double lo = min + i * bin_size;
        double up = min + (i + 1) * bin_size;
        cout << bins[i] << " | ";

        for (size_t j = 0; j < bins[i]; j++) {
            cout << "*";
        }
        cout << endl;
    }
}

int main() {
    setlocale(LC_ALL, "Russian");

    auto in = input_data();

    auto bins = make_histogram(in.numbers, in.bin_count);

    double min, max;

    double bin_size = (max - min) / in.bin_count;

    show_histogram_text(bins, min, bin_size);

    return 0;
}
